Package: NHSRdatasets
Type: Package
Title: NHS and Healthcare-Related Data for Education and Training
Date: 2021-03-09
Version: 0.3.0
Authors@R: c(
          person("Gary", "Hutson", , "g.hutson@nhs.net", "aut"),
          person("Tom", "Jemmett", ,"thomas.jemmett@nhs.net", "aut", comment = c(ORCID="0000-0002-6943-2990")),
          person("Chris", "Mainey", ,"c.mainey@nhs.net", c("aut", "cre"), comment = c(ORCID ="0000-0002-3018-6171")),
          person("Zoë", "Turner", , "zoe.turner@nhs.net", "aut" ),
          person("NHS-R community", role = "cph")
          )
Maintainer: Chris Mainey <c.mainey@nhs.net>
Description: Free United Kingdom National Health Service (NHS) and other healthcare, or population health-related data for education and training purposes. This package contains synthetic data based on real healthcare datasets, or cuts of open-licenced official data.  This package exists to support skills development in the NHS-R community: <https://nhsrcommunity.com/>.
License: CC0
Language: en-GB
Encoding: UTF-8
LazyData: true
RoxygenNote: 7.1.1
Depends: R (>= 3.5.0)
BugReports: https://github.com/nhs-r-community/NHSRdatasets/issues
Imports: tibble
Suggests: dplyr, caret, e1071, readr, lattice, magrittr, varhandle,
        rsample, ggplot2, lme4, MASS, ModelMetrics, lmtest, rmarkdown,
        scales, ggrepel, lubridate, tidyr, forcats, knitr, janitor,
        stringi, synthpop
VignetteBuilder: knitr
URL: https://github.com/nhs-r-community/NHSRdatasets,
        https://nhs-r-community.github.io/NHSRdatasets/
NeedsCompilation: no
Packaged: 2021-03-11 08:09:48 UTC; Christopher
Author: Gary Hutson [aut],
  Tom Jemmett [aut] (<https://orcid.org/0000-0002-6943-2990>),
  Chris Mainey [aut, cre] (<https://orcid.org/0000-0002-3018-6171>),
  Zoë Turner [aut],
  NHS-R community [cph]
Repository: CRAN
Date/Publication: 2021-03-14 00:00:06 UTC
Built: R 4.6.0; ; 2026-04-26 09:06:07 UTC; unix

# NHS R-community Datasets <a href='https://nhsrcommunity.com/'><img src='man/figures/logo.png' align="right" height="80" /></a>

<!-- badges: start -->

[![Travis build
status](https://api.travis-ci.org/nhs-r-community/NHSRdatasets.svg?branch=master)](https://travis-ci.org/nhs-r-community/NHSRdatasets)
[![Project Status: Active – The project has reached a stable, usable
state and is being actively
developed.](https://www.repostatus.org/badges/latest/active.svg)](https://www.repostatus.org/#active)
[![CRAN
version](https://www.r-pkg.org/badges/version/NHSRdatasets)](https://cran.r-project.org/package=NHSRdatasets)
[![Downloads](https://cranlogs.r-pkg.org/badges/grand-total/NHSRdatasets)](https://cran.r-project.org/package=NHSRdatasets)
<!-- badges: end -->

<br><br>

Please visit: <https://nhsrcommunity.com/>

## Datasources for reuse

This package has been created to help NHS, Public Health and related
analysts/data scientists learn to use `R`. It contains several free
datasets (just one at the moment), help files explaining their
structure, and `vignette` examples of their use. We encourage
contributions to the package, both to expand the set of training
material, but also as development for newer `R`/github users as a first
contribution. Please add relevant free, open source data sets that you
think may benefit the NHS R-community.

## Installation instructions

This packages is available on CRAN or the development version can be
installed from source, via this Github repository. You will need
`Rtools` (<https://cran.r-project.org/bin/windows/Rtools/>) installed to
build the package, and the `remotes` package.

``` r
remotes::install_github("https://github.com/nhs-r-community/NHSRdatasets")
```

## Contribution

Please contribute to this repository, and please cite it when you use it
in training or publications.

**To contribute, please:**

  - Fork the repository.
  - Add your dataset in the `data` folder, in `.rda` format. The best
    way to do this is with the `usethis` package with “gzip”
    compression: `usethis::use_data(data, compress="gzip")`
  - Please add a minimal `R` function to act as a help file. You can use
    the `LOS_model` as a guide.
  - Please add a `vignette` demonstrating how the data has been/can be
    used.
  - Create a pull request, detailing your additions, and we will review
    it before merging.

<br> ***When contributing a dataset, the contributor certifies that:***

  - They are the data owner, or are authorised to republish the dataset
    in question.
  - The dataset does not contain real patient-level data.
  - Where based on patient data, the contributor takes full
    responsibility for sharing the data and certifies that. it is has
    been processed, anonymised, aggregated or otherwise protected in
    accordance with all legal requirements under General Data Protection
    Regulation (GDPR), or other relevant legislation.

Please note that the ‘NHSRdatasets’ project is released with a
[Contributor Code of
Conduct](https://github.com/nhs-r-community/NHSRdatasets/blob/master/CODE_OF_CONDUCT.md).
By contributing to this project, you agree to abide by its terms.

## ----setup, include = FALSE---------------------------------------------------
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)

## ----load, warning=FALSE, message=FALSE---------------------------------------
library(NHSRdatasets)
library(dplyr)
library(ggplot2)

data("LOS_model")

head(LOS_model)

summary(LOS_model)

# 82.3% survived
prop.table(table(LOS_model$Death))

## ----VisageLOS----------------------------------------------------------------
ggplot(LOS_model, aes(x=Age)) +
  geom_histogram(alpha=0.5, col=1, fill=12, bins=20)+
  ggtitle("Distribution of Age")
ggplot(LOS_model, aes(x=LOS)) +
  geom_histogram(alpha=0.5, col=1, fill=13, bins=20)+
  ggtitle("Distribution of Length-of-Stay")

## ----glm1, collapse=TRUE------------------------------------------------------
glm_binomial <- glm(Death ~ Age + LOS, data=LOS_model, family="binomial")

summary(glm_binomial)

ModelMetrics::auc(glm_binomial)


## ----glm2---------------------------------------------------------------------
glm_binomial2<- glm(Death ~ Age + LOS + Age*LOS, data=LOS_model, family="binomial")

summary(glm_binomial2)

ModelMetrics::auc(glm_binomial2)


## ----glm5---------------------------------------------------------------------
LOS_model$preds <- predict(glm_binomial2, type="response")

head(LOS_model,5)

## ----glm3---------------------------------------------------------------------

glm_poisson <- glm(LOS ~ Age * Death, data=LOS_model, family="poisson" )

summary(glm_poisson)


## ----glm4---------------------------------------------------------------------

glm_poisson2 <- glm(LOS ~ Age + Death, data=LOS_model, family="poisson" )

AIC(glm_poisson)
AIC(glm_poisson2)

# anova(glm_poisson2, glm_poisson, test="Chisq")  will do the same thing without using the lmtest package
lmtest::lrtest(glm_poisson, glm_poisson2)


## ----od-----------------------------------------------------------------------
 sum(residuals(glm_poisson,type="pearson") ^2)/ df.residual(glm_poisson)
    


## ----quasi--------------------------------------------------------------------
quasi<-glm(LOS ~ Age * Death, data=LOS_model, family="quasipoisson" )

summary(quasi)


## ----nb, warning=FALSE, message=FALSE-----------------------------------------
library(MASS)

nb <- glm.nb(LOS ~ Age * Death, data=LOS_model,)

summary(nb)


## ----glmm, warning=FALSE------------------------------------------------------
library(lme4)

glmm <- glmer(LOS ~ scale(Age) * Death + (1|Organisation), data=LOS_model, family="poisson")

summary(glmm)

## ----confint------------------------------------------------------------------
confint(glmm)

## ----setup, include = FALSE---------------------------------------------------
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)

## ----load, warning=FALSE, message=FALSE---------------------------------------
library(NHSRdatasets)
library(dplyr)
library(ggplot2)
library(caret)
library(rsample)
library(varhandle)

data("stranded_data")
glimpse(stranded_data)
prop.table(table(stranded_data$stranded.label))

## ----feature_engineering------------------------------------------------------

stranded_data <- stranded_data %>% 
  dplyr::mutate(stranded.label=factor(stranded.label)) %>% 
  dplyr::select(everything(), -c(admit_date))



## ----dummy_encode-------------------------------------------------------------
cats <- select_if(stranded_data, is.character)
cat_dummy <- varhandle::to.dummy(cats$frailty_index, "frail_ind") 
#Converts the frailty index column to dummy encoding and sets a column called "frail_ind" prefix
cat_dummy <- cat_dummy %>% 
  as.data.frame() %>% 
  dplyr::select(-frail_ind.No_index_item) #Drop the field of interest
# Drop the frailty index from the stranded data frame and bind on our new encoding categorical variables
stranded_data <- stranded_data %>% 
  dplyr::select(-frailty_index) %>% 
  bind_cols(cat_dummy) %>% na.omit(.)


## ----train_test_split---------------------------------------------------------
split <- rsample::initial_split(stranded_data, prop = 3/4)
train <- rsample::training(split)
test <- rsample::testing(split)


## ----class_model--------------------------------------------------------------
set.seed(123)
glm_class_mod <- caret::train(factor(stranded.label) ~ ., data = train, 
                 method = "glm")
print(glm_class_mod)


## ----predicting---------------------------------------------------------------
preds <- predict(glm_class_mod, newdata = test) # Predict class
pred_prob <- predict(glm_class_mod, newdata = test, type="prob") #Predict probs

# Join prediction on to actual test data frame and evaluate in confusion matrix

predicted <- data.frame(preds, pred_prob)
test <- test %>% 
  bind_cols(predicted) %>% 
  dplyr::rename(pred_class=preds)

glimpse(test)

## ----evaluation---------------------------------------------------------------

caret::confusionMatrix(test$stranded.label, test$pred_class, positive="Stranded")

## ----setup, include = FALSE---------------------------------------------------
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)

options(tidyverse.quiet = TRUE)

## ----load data, message=TRUE, warning=TRUE------------------------------------
library(knitr)
library(scales)
library(ggrepel)
library(lubridate)
library(dplyr)
library(forcats)
library(tidyr)

library(NHSRdatasets)

data("ae_attendances")

# format for display
ae_attendances %>%
  # set the period column to show in Month-Year format
  mutate_at(vars(period), format, "%b-%y") %>% 
  # set the numeric columns to have a comma at the 1000's place
  mutate_at(vars(attendances, breaches, admissions), comma) %>%
  # show the first 10 rows
  head(10) %>%
  # format as a table
  kable()

## ----england performance------------------------------------------------------
england_performance <- ae_attendances %>%
  group_by(period) %>%
  summarise_at(vars(attendances, breaches), sum) %>%
  mutate(performance = 1 - breaches / attendances)

# format for display
england_performance %>% 
  # same format options as above
  mutate_at(vars(period), format, "%b-%y") %>% 
  mutate_at(vars(attendances, breaches), comma) %>%
  # this time show the performance column as a percentage
  mutate_at(vars(performance), percent) %>%
  # show the first 10 rows and format as a table
  head(10) %>%
  kable()

## ----england performance plot-------------------------------------------------
ggplot(england_performance, aes(period, performance)) +
  geom_line() +
  geom_point() +
  scale_y_continuous(labels = percent) +
  labs(x = "Month of attendance",
       y = "% of attendances that met the 4 hour standard",
       title = "NHS England A&E 4 Hour Performance",
       caption = "Source: NHS England Statistical Work Areas (OGL v3.0)")

## ----england performance by type----------------------------------------------
ae_attendances %>%
  group_by(period, type) %>%
  summarise_if(is.numeric, sum) %>%
  mutate(performance = 1 - breaches / attendances) %>%
  ggplot(aes(period, performance, colour = type)) +
  geom_line() +
  geom_point() +
  scale_y_continuous(labels = percent) +
  #facet_wrap(vars(type), nrow = 1) +
  theme(legend.position = "bottom") +
  labs(x = "Month of attendance",
       y = "% of attendances that met the 4 hour standard",
       title = "NHS England A&E 4 Hour Performance",
       subtitle = "By Department Type",
       caption = "Source: NHS England Statistical Work Areas (OGL v3.0)")

## ----performance_by_trust-----------------------------------------------------
performance_by_trust <- ae_attendances %>%
  group_by(org_code, period) %>%
  # make sure that this trust has a type 1 department
  filter(any(type == 1)) %>%
  summarise_at(vars(attendances, breaches), sum) %>%
  mutate(performance = 1 - breaches / attendances)

# format for display
performance_by_trust %>%
  mutate_at(vars(period), format, "%b-%y") %>% 
  mutate_at(vars(attendances, breaches), comma) %>%
  mutate_at(vars(performance), percent) %>%
  head(10) %>%
  kable()

## ----performance_by_trust_ranking---------------------------------------------
performance_by_trust_ranking <- performance_by_trust %>%
  summarise(performance = 1 - sum(breaches) / sum(attendances)) %>%
  arrange(performance) %>%
  pull(org_code) %>%
  as.character()

print("Bottom 5")
head(performance_by_trust_ranking, 5)

print("Top 5")
tail(performance_by_trust_ranking, 5)

## ----performance_by_trust top 5 bottom 5 plot---------------------------------
performance_by_trust %>%
  ungroup() %>%
  mutate_at(vars(org_code), fct_relevel, performance_by_trust_ranking) %>%
  filter(org_code %in% c(head(performance_by_trust_ranking, 5),
                         tail(performance_by_trust_ranking, 5))) %>%
  ggplot(aes(period, performance)) +
  geom_line() +
  geom_point() +
  scale_y_continuous(labels = percent) +
  facet_wrap(vars(org_code), nrow = 2) +
  theme(legend.position = "bottom") +
  labs(x = "Month of attendance",
       y = "% of attendances that met the 4 hour standard",
       title = "NHS England A&E 4 Hour Performance",
       subtitle = "Bottom 5/Top 5 over the whole 3 years",
       caption = "Source: NHS England Statistical Work Areas (OGL v3.0)")

## ----bencmarking plot---------------------------------------------------------
ae_attendances %>%
  filter(period == last(period)) %>%
  group_by(org_code) %>%
  filter(any(type == 1)) %>%
  summarise_at(vars(attendances, breaches), sum) %>%
  mutate(performance = 1 - breaches/attendances,
         overall_performance = 1 - sum(breaches)/sum(attendances),
         org_code = fct_reorder(org_code, -performance)) %>%
  #
  arrange(performance) %>%
  # lets highlight the organsiations that are at the lower and upper quartile
  # and at the median. First "tile" the data into 4 groups, then we use the
  # lag function to check to see if the value changes between rows. We will get
  # NA for the first row, so replace this with FALSE
  mutate(highlight = ntile(n = 4),
         highlight = replace_na(highlight != lag(highlight), FALSE)) %>%

  ggplot(aes(org_code, performance)) +
  geom_hline(aes(yintercept = overall_performance)) +
  geom_point(aes(fill = highlight), show.legend = FALSE, pch = 21) +
  geom_text_repel(aes(label = ifelse(highlight, as.character(org_code), NA)),
                  na.rm = TRUE) +
  scale_fill_manual(values = c("TRUE" = "black",
                               "FALSE" = NA)) +
  scale_y_continuous(labels = percent) +
  theme_minimal() +
  theme(panel.grid = element_blank(),
        axis.text.x = element_blank(),
        axis.line = element_line(),
        axis.ticks.y = element_line())

## ----setup, include = FALSE---------------------------------------------------

knitr::opts_chunk$set(echo=TRUE, warning=FALSE, message=FALSE, eval=FALSE)


## ----webscraping--------------------------------------------------------------
#  # 2019
#  download.file(
#    "https://www.ons.gov.uk/file?uri=%2fpeoplepopulationandcommunity%2fbirthsdeathsandmarriages%2fdeaths%2fdatasets%2fweeklyprovisionalfiguresondeathsregisteredinenglandandwales%2f2019/publishedweek522019.xls",
#    destfile = "2019Mortality.xls",
#    method = "wininet",
#    mode = "wb")
#  
#  # 2018
#  download.file(
#    "https://www.ons.gov.uk/file?uri=%2fpeoplepopulationandcommunity%2fbirthsdeathsandmarriages%2fdeaths%2fdatasets%2fweeklyprovisionalfiguresondeathsregisteredinenglandandwales%2f2018/publishedweek522018withupdatedrespiratoryrow.xls",
#    destfile = "2018Mortality.xls",
#    method = "wininet",
#    mode = "wb")
#  
#  # 2017
#  download.file(
#    "https://www.ons.gov.uk/file?uri=%2fpeoplepopulationandcommunity%2fbirthsdeathsandmarriages%2fdeaths%2fdatasets%2fweeklyprovisionalfiguresondeathsregisteredinenglandandwales%2f2017/publishedweek522017.xls",
#    destfile = "2017Mortality.xls",
#    method = "wininet",
#    mode = "wb")
#  
#  # 2016
#  download.file(
#    "https://www.ons.gov.uk/file?uri=%2fpeoplepopulationandcommunity%2fbirthsdeathsandmarriages%2fdeaths%2fdatasets%2fweeklyprovisionalfiguresondeathsregisteredinenglandandwales%2f2016/publishedweek522016.xls",
#    destfile = "2016Mortality.xls",
#    method = "wininet",
#    mode = "wb")
#  
#  # 2015
#  download.file(
#    "https://www.ons.gov.uk/file?uri=%2fpeoplepopulationandcommunity%2fbirthsdeathsandmarriages%2fdeaths%2fdatasets%2fweeklyprovisionalfiguresondeathsregisteredinenglandandwales%2f2015/publishedweek2015.xls",
#    destfile = "2015Mortality.xls",
#    method = "wininet",
#    mode = "wb")
#  
#  # 2014
#  download.file(
#    "https://www.ons.gov.uk/file?uri=%2fpeoplepopulationandcommunity%2fbirthsdeathsandmarriages%2fdeaths%2fdatasets%2fweeklyprovisionalfiguresondeathsregisteredinenglandandwales%2f2014/publishedweek2014.xls",
#    destfile = "2014Mortality.xls",
#    method = "wininet",
#    mode = "wb")
#  
#  # 2013
#  download.file(
#    "https://www.ons.gov.uk/file?uri=%2fpeoplepopulationandcommunity%2fbirthsdeathsandmarriages%2fdeaths%2fdatasets%2fweeklyprovisionalfiguresondeathsregisteredinenglandandwales%2f2013/publishedweek2013.xls",
#    destfile = "2013Mortality.xls",
#    method = "wininet",
#    mode = "wb")
#  
#  # 2012
#  download.file(
#    "https://www.ons.gov.uk/file?uri=%2fpeoplepopulationandcommunity%2fbirthsdeathsandmarriages%2fdeaths%2fdatasets%2fweeklyprovisionalfiguresondeathsregisteredinenglandandwales%2f2012/publishedweek2012.xls",
#    destfile = "2012Mortality.xls",
#    method = "wininet",
#    mode = "wb")
#  
#  # 2011
#  download.file(
#    "https://www.ons.gov.uk/file?uri=%2fpeoplepopulationandcommunity%2fbirthsdeathsandmarriages%2fdeaths%2fdatasets%2fweeklyprovisionalfiguresondeathsregisteredinenglandandwales%2f2011/publishedweek2011.xls",
#    destfile = "2011Mortality.xls",
#    method = "wininet",
#    mode = "wb")
#  
#  # 2010
#  download.file(
#    "https://www.ons.gov.uk/file?uri=%2fpeoplepopulationandcommunity%2fbirthsdeathsandmarriages%2fdeaths%2fdatasets%2fweeklyprovisionalfiguresondeathsregisteredinenglandandwales%2f2010/publishedweek2010.xls",
#    destfile = "2010Mortality.xls",
#    method = "wininet",
#    mode = "wb")
#  

## ----extracting worksheets----------------------------------------------------
#  
#  library(readxl)
#  library(dplyr)
#  
#  files_list <- list.files(path = "working_files",
#                           pattern = "*.xls",
#                           full.names = TRUE)
#  
#  
#  read_then_csv <- function(sheet, path) {
#    pathbase <- path %>%
#      basename() %>%
#      tools::file_path_sans_ext()
#    path %>%
#      read_excel(sheet = sheet) %>%
#      write_csv(paste0(pathbase, "-", sheet, ".csv"))
#  }
#  
#  
#  for(j in 1:length(files_list)){
#  
#    path <- paste0(files_list[j])
#  
#    path %>%
#      excel_sheets() %>%
#      set_names() %>%
#      map(read_then_csv, path = path)
#  }
#  

## ----load_files---------------------------------------------------------------
#  
#  files_list_sheets <- list.files(path = "working_files",
#                           pattern = "Weekly",
#                           full.names = TRUE
#                           )
#  
#  for(i in files_list_sheets) {
#  
#    x <- read_csv((i), col_types = cols(.default = col_character()))
#  
#    assign(i, x)
#  }
#  

## ----format function 2010 to 2015---------------------------------------------
#  
#  library(janitor)
#  library(tidyr)
#  library(stringi)
#  library(lubridate)
#  
#  # Column names that are not related to data points to be removed. This is the same for all years' spreadsheets.
#  # Note that single quotes are used for the categories as one sentence includes '' in the text (4).
#  
#  remove_lookup <- c('week over the previous five years1',
#    'Deaths by underlying cause2,3',
#    'Footnotes',
#    '1 This average is based on the actual number of death registrations recorded for each corresponding week over the previous five years. Moveable public holidays, when register offices are closed, affect the number of registrations made in the published weeks and in the corresponding weeks in previous years.',
#    '2 Counts of deaths by underlying cause exclude deaths at age under 28 days.',
#    '3 Coding of deaths by underlying cause for the latest week is not yet complete.',
#    "4Does not include deaths where age is either missing or not yet fully coded. For this reason counts of 'Persons', 'Males' and 'Females' may not sum to 'Total Deaths, all ages'.",
#    '5 Does not include deaths of those resident outside England and Wales or those records where the place of residence is either missing or not yet fully coded. For this reason counts for "Deaths by Region of usual residence" may not sum to "Total deaths, all ages".',
#    'Source: Office for National Statistics',
#    'Deaths by age group'
#  )
#  
#  formatFunction <- function(file){
#  
#  ONS <- file %>%
#    clean_names %>%
#    remove_empty(c("rows","cols")) %>%
#    filter(!contents %in% remove_lookup) %>%
#  
#    # useful categories are found in the column contents but also include the footnote number
#    mutate(Category = case_when(is.na(x2) & str_detect(contents, "Region") ~ "Region",
#                                is.na(x2) & str_detect(contents, "Persons") ~ "Persons",
#                                is.na(x2) & str_detect(contents, "Females") ~ "Females",
#                                is.na(x2) & str_detect(contents, "Males") ~ "Males")
#    ) %>%
#    select(contents, Category, everything()) %>%
#  
#    # to ensure data like Persons, Males and Females
#    fill(Category) %>%
#  
#    # categories with Persons, Males and Females in the original column do not correspond directly to data points (wide form data) so are removed by referring to str_detect to find the word
#    filter(!str_detect(contents, "Persons"),
#           !str_detect(contents, "Males"),
#           !str_detect(contents, "Females")) %>%
#  
#    # the two columns for Category and contents are merged to Categories to bring the Category column first. Some categories don't have subcategories and these are preceded by NA_ with this merge
#    unite("Categories", Category, contents) %>%
#    filter(Categories != "Region_Deaths by Region of usual residence 5") %>%
#  
#    # the NA_ is removed from some of the category names
#    mutate(Categories = case_when(str_detect(Categories, "NA_") ~ str_replace(Categories, "NA_", ""),
#                                  TRUE ~ Categories))
#  
#    # Push date row to column names
#  onsFormattedJanitor <- row_to_names(ONS, 3)
#  
#    # move data from wide to long form using pivot_longer
#  x <- onsFormattedJanitor %>%
#    pivot_longer(cols = -`Week ended`,
#                 names_to = "allDates",
#                 values_to = "counts") %>%
#  
#    # some spreadsheets import with Excel serial numbers for dates and others as dates, janitor is used to correct this
#    mutate(realDate = dmy(allDates),
#           ExcelSerialDate = case_when(stri_length(allDates) == 5 ~ excel_numeric_to_date(as.numeric(allDates), date_system = "modern")),
#           date = case_when(is.na(realDate) ~ ExcelSerialDate,
#                            TRUE ~ realDate)) %>%
#    group_by(`Week ended`) %>%
#  
#    # the week number is replaced as this was lost with the moving of dates to the column headers
#    mutate(week_no = row_number()) %>%
#    ungroup() %>%
#  
#    # Category is a staging name as this is followed by a splitting of the column into category_1 and category_2
#    rename(Category = `Week ended`) %>%
#  
#    # to split the columns there are various characters used as a split point ",", "-", and ":" in the respiratory category the version is denoted by "v"
#    mutate(category_1 = case_when(str_detect(Category, ",") ~
#                                    substr(Category,1,str_locate(Category, ",") -1),
#                                  str_detect(Category, ":") ~
#                                    substr(Category,1,str_locate(Category, ":") -1),
#                                  str_detect(Category, "_") ~
#                                    substr(Category,1,str_locate(Category, "_") -1),
#                                  str_detect(Category, "respiratory")  ~
#                                    "All respiratory diseases (ICD-10 J00-J99) ICD-10"),
#           category_2 = case_when(str_detect(Category, ",") ~
#                                    substr(Category,str_locate(Category, ", ") +2, str_length(Category)),
#                                  str_detect(Category, ":") ~
#                                    substr(Category,str_locate(Category, ": ") +2, str_length(Category)),
#                                  str_detect(Category, "_") ~
#                                    substr(Category,str_locate(Category, "_") +1, str_length(Category)),
#                                  str_detect(Category, "respiratory")  ~
#                                    substr(Category,str_locate(Category, "v"), str_length(Category)) ),
#  
#           # the data for Total deaths: average of corresponding week over the previous 5 years is split over two cells in the spreasheet
#           category_2 = recode(category_2,
#                               "average of corresponding" = "average of same week over 5 years")) %>%
#    select(category_1,
#           category_2,
#           counts,
#           date,
#           week_no
#           ) %>%
#  
#    # 2011 requires this code to remove rows where there are no counts and because there are 2 rows relating to respiratory death numbers (see the Respiratory section) the previous methodology has been included in the spreadsheet with : for counts. This code does not affect other years' data/
#    filter(!is.na(counts),
#           counts != ":") %>%
#    fill(category_1)
#  
#  return(x)
#  
#  }
#  
#  Mortality2010 <- formatFunction(`working_files/Weekly/2010Mortality-Weekly Figures 2010.csv`)
#  
#  # 2011 has two lines relating to respiratory, v 2001 only has one data point and the rest of the year is 2010
#  Mortality2011 <- formatFunction(`working_files/Weekly/2011Mortality-Weekly Figures 2011.csv`) %>%
#    mutate(category_2 = case_when(is.na(category_2) & category_1 == "All respiratory diseases (ICD-10 J00-J99) ICD-10" ~ "v 2010",
#                                  TRUE ~ category_2))
#  
#  Mortality2012 <- formatFunction(`working_files/Weekly/2012Mortality-Weekly Figures 2012.csv`)
#  Mortality2013 <- formatFunction(`working_files/Weekly/2013Mortality-Weekly Figures 2013.csv`)
#  Mortality2014 <- formatFunction(`working_files/Weekly/2014Mortality-Weekly Figures 2014.csv`)
#  Mortality2015 <- formatFunction(`working_files/Weekly/2015Mortality-Weekly Figures 2015.csv`)
#  

## ----format function 2016 to 2019---------------------------------------------
#  
#  formatFunction2016 <- function(file){
#  
#    ONS <- file %>%
#      clean_names %>%
#  
#      # An extra column has been added for region codes (not included in the dataset) meaning contents are now found in the janitor generated column name x2
#      mutate(x2 = case_when(is.na(x2) ~ contents,
#                                TRUE ~ x2)) %>%
#      remove_empty(c("rows","cols")) %>%
#      select(-contents) %>%
#      filter(!x2 %in% remove_lookup) %>%
#  
#      # Region has changed to region
#      mutate(Category = case_when(is.na(x3) & str_detect(x2, "region") ~ "Region",
#                                  is.na(x3) & str_detect(x2, "Persons") ~ "Persons",
#                                  is.na(x3) & str_detect(x2, "Females") ~ "Females",
#                                  is.na(x3) & str_detect(x2, "Males") ~ "Males",
#                                  TRUE ~ NA_character_)
#      ) %>%
#      select(x2, Category, everything()) %>%
#      fill(Category) %>%
#      filter(!str_detect(x2, 'Persons'),
#             !str_detect(x2, 'Males'),
#             !str_detect(x2, 'Females')) %>%
#      unite("Categories", Category, x2) %>%
#      filter(Categories != 'Region_Deaths by Region of usual residence 5') %>%
#      mutate(Categories = case_when(str_detect(Categories, "NA_") ~ str_replace(Categories, "NA_", ""),
#                                    TRUE ~ Categories))
#  
#    # Push date row to column names
#    onsFormattedJanitor <- row_to_names(ONS, 3)
#  
#    # move data from wide to long form using pivot_longer
#    x <- onsFormattedJanitor %>%
#      pivot_longer(cols = -`Week ended`,
#                   names_to = "allDates",
#                   values_to = "counts") %>%
#      mutate(realDate = dmy(allDates),
#             ExcelSerialDate = case_when(stri_length(allDates) == 5 ~ excel_numeric_to_date(as.numeric(allDates), date_system = "modern")),
#             date = case_when(is.na(realDate) ~ ExcelSerialDate,
#                              TRUE ~ realDate)) %>%
#      group_by(`Week ended`) %>%
#      mutate(week_no = row_number()) %>%
#      ungroup() %>%
#      rename(Category = `Week ended`) %>%
#      mutate(category_1 = case_when(str_detect(Category, ",") ~
#                                    substr(Category,1,str_locate(Category, ",") -1),
#                                  str_detect(Category, ":") ~
#                                    substr(Category,1,str_locate(Category, ":") -1),
#                                  str_detect(Category, "_") ~
#                                    substr(Category,1,str_locate(Category, "_") -1),
#                                  str_detect(Category, "respiratory")  ~
#                                    "All respiratory diseases (ICD-10 J00-J99) ICD-10"),
#           category_2 = case_when(str_detect(Category, ",") ~
#                                    substr(Category,str_locate(Category, ", ") +2, str_length(Category)),
#                                  str_detect(Category, ":") ~
#                                    substr(Category,str_locate(Category, ": ") +2, str_length(Category)),
#                                  str_detect(Category, "_") ~
#                                    substr(Category,str_locate(Category, "_") +1, str_length(Category)),
#                                  str_detect(Category, "respiratory")  ~
#                                    substr(Category,str_locate(Category, "v"), str_length(Category)) ),
#           category_2 = recode(category_2,
#                               "average of corresponding" = "average of same week over 5 years")) %>%
#      select(category_1,
#             category_2,
#             counts,
#             date,
#             week_no
#      ) %>%
#      filter(!is.na(counts))
#  
#    return(x)
#  
#  }
#  
#  
#  Mortality2016 <- formatFunction2016(`working_files/Weekly/2016Mortality-Weekly figures 2016.csv`)
#  Mortality2017 <- formatFunction2016(`working_files/Weekly/2017Mortality-Weekly figures 2017.csv`)
#  Mortality2018 <- formatFunction2016(`working_files/Weekly/2018Mortality-Weekly figures 2018.csv`)
#  Mortality2019 <- formatFunction2016(`working_files/Weekly/2019Mortality-Weekly figures 2019.csv`)
#  

## ----bind together------------------------------------------------------------
#  
#  ons_mortality <- do.call("rbind", list(
#                        Mortality2010,
#                        Mortality2011,
#                        Mortality2012,
#                        Mortality2013,
#                        Mortality2014,
#                        Mortality2015,
#                        Mortality2016,
#                        Mortality2017,
#                        Mortality2018,
#                        Mortality2019))
#  

## ----load, warning=FALSE, message=FALSE---------------------------------------
#  
#  library(NHSRdatasets)
#  library(dplyr)
#  
#  data("ons_mortality")
#  

## ----respiratory categories---------------------------------------------------
#  
#  ons_mortality %>%
#    mutate(year = year(date)) %>%
#    select(year, category_1, category_2) %>%
#    group_by(year, category_1, category_2) %>%
#    filter(category_1 == 'All respiratory diseases (ICD-10 J00-J99) ICD-10') %>%
#    slice(1)
#  

## ----age bands----------------------------------------------------------------
#  
#  ons_mortality %>%
#    select(category_1, category_2) %>%
#    group_by(category_1, category_2) %>%
#    filter(category_1 %in% c('Persons','Females','Males')) %>%
#    slice(1)
#  

## ----removefiles--------------------------------------------------------------
#  unlink("working_files", recursive = TRUE)

## ----setup, include = FALSE---------------------------------------------------
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)

## ----observed_data_generation-------------------------------------------------
library(readr)
library(dplyr)
df <- suppressWarnings(read_csv("https://raw.githubusercontent.com/StatsGary/SyntheticNEWSData/main/observed_news_data.csv") %>% 
  dplyr::select(everything(), -X1))

glimpse(df)


## ----synth--------------------------------------------------------------------
library(synthpop)  
syn_df <- syn(df,seed=4321)
#### synthetic data
synthetic_news_data <- syn_df$syn
glimpse(synthetic_news_data)


## ----visuals------------------------------------------------------------------
library(ggplot2)
#Create temperature tibbles to compare observed vs synthetically generated labels
obs <- tibble(label="observed_data", value = df$temp)
synth <- tibble(label="synthetic_data",value = synthetic_news_data$temp)

#Merge the frames together to get a comparison
merged <- obs %>% 
  bind_rows(synth)

#Create the plot
plot <- merged %>% 
  ggplot(aes(value, fill = label)) +
  geom_histogram(alpha = 0.9, position = 'identity')  + theme_minimal() + 
  scale_fill_manual(values=c("#BCBDC1", "#2061AC")) +
  labs(title="Observed vs Synthetically NEWS values",
       subtitle="Based on NEWS Temperature score",
       x="NEWS Temperature Score", y="Score frequency") + 
  theme(legend.position = "none")

print(plot)

---
title: "ae_attendances dataset"
author:
- '[Tom Jemmett][tj_email], [The Strategy Unit][su_web]'
date: "15/08/2019"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{ae_attendances dataset}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r setup, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)

options(tidyverse.quiet = TRUE)
```

This vignette explains how to use the `ae_attendances` dataset in R, and also
details where it comes from and how it is generated.

The data is sourced from [NHS England Statistical Work Areas][nhs_swa]
and is available under the [Open Government Licence v3.0][ogl_v3].

The data contains all reported A&E attendances for the period April 2016 through
March 2019

The dataset contains:

- __period__: the month that this activity relates to, stored as a date (1st of each month)
- __org_code__: the [ODS][ods]
code for the organisation that this activity relates to
- __type__: the [Department Type][ae_types]
for this activity, either 1, 2, or other
- __attendances__: the number of attendances for this department type at this organisation
for this month
- __breaches__: the number of attendances that breached the 4 hour target
- __admissions__: the number of attendances that resulted in an admission to the
hospital

First let's load some packages and the dataset and show the first 10 rows of data.

```{r load data, message=TRUE, warning=TRUE}
library(knitr)
library(scales)
library(ggrepel)
library(lubridate)
library(dplyr)
library(forcats)
library(tidyr)

library(NHSRdatasets)

data("ae_attendances")

# format for display
ae_attendances %>%
  # set the period column to show in Month-Year format
  mutate_at(vars(period), format, "%b-%y") %>% 
  # set the numeric columns to have a comma at the 1000's place
  mutate_at(vars(attendances, breaches, admissions), comma) %>%
  # show the first 10 rows
  head(10) %>%
  # format as a table
  kable()
```

We can calculate the 4 hours performance for England as a whole like so:

```{r england performance}
england_performance <- ae_attendances %>%
  group_by(period) %>%
  summarise_at(vars(attendances, breaches), sum) %>%
  mutate(performance = 1 - breaches / attendances)

# format for display
england_performance %>% 
  # same format options as above
  mutate_at(vars(period), format, "%b-%y") %>% 
  mutate_at(vars(attendances, breaches), comma) %>%
  # this time show the performance column as a percentage
  mutate_at(vars(performance), percent) %>%
  # show the first 10 rows and format as a table
  head(10) %>%
  kable()
```

We can now plot the monthly performance

```{r england performance plot}
ggplot(england_performance, aes(period, performance)) +
  geom_line() +
  geom_point() +
  scale_y_continuous(labels = percent) +
  labs(x = "Month of attendance",
       y = "% of attendances that met the 4 hour standard",
       title = "NHS England A&E 4 Hour Performance",
       caption = "Source: NHS England Statistical Work Areas (OGL v3.0)")
```

We can clearly see the "Winter Pressures" where performance drops.

We can also inspect performance for the [different types of department][ae_types]:

```{r england performance by type}
ae_attendances %>%
  group_by(period, type) %>%
  summarise_if(is.numeric, sum) %>%
  mutate(performance = 1 - breaches / attendances) %>%
  ggplot(aes(period, performance, colour = type)) +
  geom_line() +
  geom_point() +
  scale_y_continuous(labels = percent) +
  #facet_wrap(vars(type), nrow = 1) +
  theme(legend.position = "bottom") +
  labs(x = "Month of attendance",
       y = "% of attendances that met the 4 hour standard",
       title = "NHS England A&E 4 Hour Performance",
       subtitle = "By Department Type",
       caption = "Source: NHS England Statistical Work Areas (OGL v3.0)")
```

From this it appears as if only the type 1 departments have the seasonal
drops, type 2 and "other" departments remain pretty consistent.

## What are the best and worst trusts for performance?

We could create a similar table of data for performance by each individual trust,
but it would be useful to only look at trusts that have a type 1 department as
it appears from the chart above that these departments have the largest
variation.

```{r performance_by_trust}
performance_by_trust <- ae_attendances %>%
  group_by(org_code, period) %>%
  # make sure that this trust has a type 1 department
  filter(any(type == 1)) %>%
  summarise_at(vars(attendances, breaches), sum) %>%
  mutate(performance = 1 - breaches / attendances)

# format for display
performance_by_trust %>%
  mutate_at(vars(period), format, "%b-%y") %>% 
  mutate_at(vars(attendances, breaches), comma) %>%
  mutate_at(vars(performance), percent) %>%
  head(10) %>%
  kable()
```

From this table we can calculate the overall performance by each trust and then
organise the trusts by their overall performance.

```{r performance_by_trust_ranking}
performance_by_trust_ranking <- performance_by_trust %>%
  summarise(performance = 1 - sum(breaches) / sum(attendances)) %>%
  arrange(performance) %>%
  pull(org_code) %>%
  as.character()

print("Bottom 5")
head(performance_by_trust_ranking, 5)

print("Top 5")
tail(performance_by_trust_ranking, 5)
```

```{r performance_by_trust top 5 bottom 5 plot}
performance_by_trust %>%
  ungroup() %>%
  mutate_at(vars(org_code), fct_relevel, performance_by_trust_ranking) %>%
  filter(org_code %in% c(head(performance_by_trust_ranking, 5),
                         tail(performance_by_trust_ranking, 5))) %>%
  ggplot(aes(period, performance)) +
  geom_line() +
  geom_point() +
  scale_y_continuous(labels = percent) +
  facet_wrap(vars(org_code), nrow = 2) +
  theme(legend.position = "bottom") +
  labs(x = "Month of attendance",
       y = "% of attendances that met the 4 hour standard",
       title = "NHS England A&E 4 Hour Performance",
       subtitle = "Bottom 5/Top 5 over the whole 3 years",
       caption = "Source: NHS England Statistical Work Areas (OGL v3.0)")
```

## Benchmarking

It is sometimes useful to see how an organisation stacks up against all of the
other organisations. Below we create a chart where each organisation is shown as
a point, ordered by performance from left (highest performance) to right (lowest)
performance.

It's useful to indicate certain organisations on the chart, below I am showing
the 3 organisations that are at the lower quartile, median and upper quartile,
however you could change this to instead pick out specific organisations (using
a reference table and `left_join` or hard coding with `case_when`).

```{r bencmarking plot}
ae_attendances %>%
  filter(period == last(period)) %>%
  group_by(org_code) %>%
  filter(any(type == 1)) %>%
  summarise_at(vars(attendances, breaches), sum) %>%
  mutate(performance = 1 - breaches/attendances,
         overall_performance = 1 - sum(breaches)/sum(attendances),
         org_code = fct_reorder(org_code, -performance)) %>%
  #
  arrange(performance) %>%
  # lets highlight the organsiations that are at the lower and upper quartile
  # and at the median. First "tile" the data into 4 groups, then we use the
  # lag function to check to see if the value changes between rows. We will get
  # NA for the first row, so replace this with FALSE
  mutate(highlight = ntile(n = 4),
         highlight = replace_na(highlight != lag(highlight), FALSE)) %>%

  ggplot(aes(org_code, performance)) +
  geom_hline(aes(yintercept = overall_performance)) +
  geom_point(aes(fill = highlight), show.legend = FALSE, pch = 21) +
  geom_text_repel(aes(label = ifelse(highlight, as.character(org_code), NA)),
                  na.rm = TRUE) +
  scale_fill_manual(values = c("TRUE" = "black",
                               "FALSE" = NA)) +
  scale_y_continuous(labels = percent) +
  theme_minimal() +
  theme(panel.grid = element_blank(),
        axis.text.x = element_blank(),
        axis.line = element_line(),
        axis.ticks.y = element_line())
```

[//]: <> (URL's / References --------------------------------------------------)
[tj_email]: mailto:thomas.jemmett@nhs.net
[su_web]:   https://www.strategyunitwm.nhs.uk/ 
[nhs_swa]:  https://www.england.nhs.uk/statistics/statistical-work-areas/ae-waiting-times-and-activity/
[ogl_v3]:   https://www.nationalarchives.gov.uk/doc/open-government-licence/version/3/
[ods]:      https://digital.nhs.uk/services/organisation-data-service
[ae_types]: https://web.archive.org/web/20200128111444/https://www.datadictionary.nhs.uk/data_dictionary/attributes/a/acc/accident_and_emergency_department_type_de.asp

---
title: "Stranded Model Tutorial"
author: "Gary Hutson"
date: "`r Sys.Date()`"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{Stranded Model Tutorial}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r setup, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)
```

This vignette details why the `stranded_model` dataset was created, how to load it, and gives examples of use with the caret Machine Learning library.

The dataset contains:

- __stranded.label:__ a character metric to indicate whether the patient is stranded, or not
- __age:__ Integer - the age of the patient on admission to hospital
- __care.home.referral:__ Integer - flag to indicate referred from care home
- __medicallysafe:__ Integer - flag to indicate whether the patient is medically safe e.g. safe to be discharged but hasn't been
- __hcop:__ Integer - flag to indicate whether the patient is in a Health Care for Older People area
- __mental_health_care:__ Integer - flag to indicate mental health care provision
- __period_of_previous_care:__ Integer - flag to indicate previous periods of care
- __admit_date:__ Date - admit date
- __frailty_index:__ Character - specifying frailty type, if frail

## First, load the data and inspect it

```{r load, warning=FALSE, message=FALSE}
library(NHSRdatasets)
library(dplyr)
library(ggplot2)
library(caret)
library(rsample)
library(varhandle)

data("stranded_data")
glimpse(stranded_data)
prop.table(table(stranded_data$stranded.label))
```

This is good, it shows a relatively even split between the not stranded and stranded labels. Please refer to the webinar on [Advanced Modelling](https://www.youtube.com/watch?v=rO40vvKXU-4&t=1360s) to look at how you can deal with classification imbalance using techniques such as SMOTE (Synthetic Minority Oversampling Technique Estimation) and ROSE (Random Oversampling Estimation), to name a few. 

## Feature engineering

The next step will be to decide which features need to be engineered for our machine learning model. We will drop the admit_date and recode the frailty index, and perhaps allocate the age into age bands. 

```{r feature_engineering}

stranded_data <- stranded_data %>% 
  dplyr::mutate(stranded.label=factor(stranded.label)) %>% 
  dplyr::select(everything(), -c(admit_date))


```
Next, I will select the categorical variables and make these into dummy variables, i.e. a numerical encoding of a categorical variable:

```{r dummy_encode}
cats <- select_if(stranded_data, is.character)
cat_dummy <- varhandle::to.dummy(cats$frailty_index, "frail_ind") 
#Converts the frailty index column to dummy encoding and sets a column called "frail_ind" prefix
cat_dummy <- cat_dummy %>% 
  as.data.frame() %>% 
  dplyr::select(-frail_ind.No_index_item) #Drop the field of interest
# Drop the frailty index from the stranded data frame and bind on our new encoding categorical variables
stranded_data <- stranded_data %>% 
  dplyr::select(-frailty_index) %>% 
  bind_cols(cat_dummy) %>% na.omit(.)

```

The data is now ready for splitting into a simple train and validation split, to do the machine learning on the set.

## Splitting the data

The next step is to create a simple hold out train/test split:

```{r train_test_split}
split <- rsample::initial_split(stranded_data, prop = 3/4)
train <- rsample::training(split)
test <- rsample::testing(split)

```


## Create simple Logistic Regression Model to classify stranded patients

The next step will be to create a stranded classification model, in CARET:

```{r class_model}
set.seed(123)
glm_class_mod <- caret::train(factor(stranded.label) ~ ., data = train, 
                 method = "glm")
print(glm_class_mod)

```

This is a very basic model and could be improved by model choice, hyperparameter selection, different resampling strategies, etc.


## Predicting the test set to validate model

Next, we will use the test dataset to see how our model will perform in the wild:

```{r predicting}
preds <- predict(glm_class_mod, newdata = test) # Predict class
pred_prob <- predict(glm_class_mod, newdata = test, type="prob") #Predict probs

# Join prediction on to actual test data frame and evaluate in confusion matrix

predicted <- data.frame(preds, pred_prob)
test <- test %>% 
  bind_cols(predicted) %>% 
  dplyr::rename(pred_class=preds)

glimpse(test)
```

## Evaluating with confusion matrix

The final step is to evaluate the model:

```{r evaluation}

caret::confusionMatrix(test$stranded.label, test$pred_class, positive="Stranded")

```

The model performs relatively well and could be improved by better predictors, a bigger sample and class imbalance techniques. 

## Conclusion

This dataset can be used for a number of classification problems and can be the NHS's equivalent to the iris dataset for classification, albeit this only works for binary classification problems. 
